var Battle = {
	Start: function(formation)
	{
		//this.EnterBattleAnimation();	// yay!!
		this.ColorBattleAnimation();	// yay!!!
		Common.LoadingIcon.blit(16, 16);
		FlipScreen();
		var oldmusic = Music.GetCurrent();
		Music.Play("battle.ogg");
		Screen.NeverRenderMap = true;
		var data = Data.Load("battle/" + formation + ".battleData");
		this.CurrentBattle = new this.Battle(data);
		Screen.Attach(this.CurrentBattle);
		Screen.Input(this.CurrentBattle);
		var f = new FadeInFromTop();
		Screen.AttachPostRenderEffect(f);
		f.Monitor = true;
		this.CurrentBattle.Init();
		while (!this.CurrentBattle.Completed)
		{
			Screen.Frame();
		}
		var f = Screen.AttachPostRenderEffect(new FadeOutFromTop());
		while (!f.Completed) Screen.Frame();
		Screen.DetachPostRenderEffect(f);
		this.CurrentBattle.CleanUp();
		Screen.Detach(this.CurrentBattle);
		Screen.NeverRenderMap = false;
		Music.Resume(oldmusic);
		Map.FadeIn();
	},
	
	
	Battle: function(battleData)
	{
		this.Background = LoadImage(battleData.Background);
		this.Completed = false;
		this.ActionQueue = [];
		this.ActionIndex = -1;
		this.EXPGained = 0;
		this.GilGained = 0;
		this.Actions = [];
		this.Data = battleData;
		this.Init = function()
		{
			this.Monsters = [];
			for (var i = 0; i < this.Data.Monsters.length; i++)
			{
				monster = new Monster(Data.Load("monsters/" + this.Data.Monsters[i].Data + ".monsterData"));
				if (!monster.Destroy)
				{
					monster.currentY = this.Data.Monsters[i].y;
					monster.currentX = -monster.Spriteset.images[0].width;
					monster.ResetATB();
					monster.BackRow = this.Data.Monsters[i].BackRow ? true : false;
					this.Monsters.push(monster);
					Screen.Attach(monster);
					monster.MoveTo(this.Data.Monsters[i].x, this.Data.Monsters[i].y, 30);
				}
			}
			for (var i = 0; i < Party.Characters.length; i++)
			{
				Party.Characters[i].currentX = 248 + (Party.Characters[i].BackRow ? 24 : 0);
				Party.Characters[i].currentY = 52 + 26 * i;
				Party.Characters[i].StartBattle();
				Screen.Attach(Party.Characters[i]);
			}
			this.TriggerScript("BattleStart");
		}
		this.CleanUp = function()
		{
			for (var i = 0; i < Party.Characters.length; i++)
			{
				Screen.Detach(Party.Characters[i]);
			}
			for (var i = 0; i < this.Monsters.length; i++)
			{
				Screen.Detach(this.Monsters[i]);
			}
		}
		this.QueueAction = function(o)
		{
			this.Actions.push(o);
		}
		this.AttackHits = function(target, source, attack, hit, evade, multipenalty)
		{
			if (target.Status.Dead) return false;
			if (attack.Type == "Magic")
			{
			/*1)  If Spell Hit% = A, the attack automatically hits.  Goto Step 10.
2)  If the Attacker is targetting his own party members and the spell
    automatically hits its own party members, the attack automatically hits.
    Goto Step 10.
3)  If the Target's  "Can't Evade" parameter matches the attacking magic type
    (White, Black, Time, Summon, Song or Blue), the attack automatically hits.
    Goto Step 10.
4)  Hit% = Spell Hit% + Attacker Level - Target Level
    Evade% = Target Magic Evade%
5)  Check to see if Aegis Shield magic block succeeds (6.3.2).  If so, the
    attack misses;  do not follow any more steps.  The Target cannot evade with
    Aegis Shield if he has Sleep, Paralyze, Charm or Stop status or is attacking
    himself.
6)  Apply multitargetting modifier to Hit% (6.3.3)
7)  Apply Target status effect modifiers to magic Hit% (6.3.6)
8)  Let N1 = (0..99)  
    If N1 >= Hit%, the attack misses;  do not follow any more steps.
9)  Let N2 = (0..99)  
    If N2 < Evade%, the attack misses;  do not follow any more steps.
10)  The attack hits.  Follow the rest of the steps to calculate damage.*/
				if (attack.HitPcnt == 100) return true;
				if (multipenalty) hit = Math.floor(hit / 2);
				var n1 = Random(0,99);
				if (n1 >= hit) return false;
				var n2 = Random(0,99);
				if (n2 < evade) return false;
				return true;
			}
			if (attack.Type == "Physical")
			{
				if (target.Status.Sleep || target.Status.Charm || target.Status.Paralyze) return true;
				
				if (source == target) return true;
				
				// TODO: check if target can't evade physical
			
				if (target.Status.Toad) evade = 0;
				if (target.Status.Mini) evade = Math.min(evade * 2, 99);
				
				if (source.Status.Blind) hit = Math.floor(hit / 4);
				
				var n1 = Random(0,99);
				if (n1 >= hit) return false;
				
				if (!target.Status.Stop)
				{
					var n2 = Random(0, 99);
					if (n2 < evade) return false;
				}
			
				if (target.Status.Image) return false;
			
				return true;
			}
			return false;
		}
		this.SelectTarget = function(all)
		{
			var sel = Screen.Attach(new TargetSelector(all));
			Screen.Input(sel);
			while (!sel.Completed)
			{
				Screen.Frame();
			}
			Screen.Detach(sel);
			return sel.Targets;
		}
		this.Damage = function(target, source, attack, multipenalty)
		{
			var damage = attack.CalculateDamage({Target: target, Source: source, CurrentAttack: attack, MultiPenalty: multipenalty});
			if (damage !== false) target.TakeDamage(damage);
			Screen.AttachPostRenderEffect(new DamageNumbers(damage === false ? "M" : damage, target)).Monitor = true;
			return (damage === false) ? false : true;
		}
		this.RemoveMonster = function(monster)
		{
			for (var i = 0; i < this.Monsters.length; i++)
			{
				if (this.Monsters[i] == monster)
				{
					this.Monsters.splice(i, 1);
					return;
				}
			}
		}
		this.TriggerScript = function(s, ScriptArguments)
		{
			if (this.Data.Scripts && this.Data.Scripts[s])
				return RunScript("../data/battle/" + this.Data.Scripts[s], true, ScriptArguments);
			return null;
		}
		this.DoMessage = function(msg, time)
		{
			var ow = this.Wait;
			var m = new Message(msg, true);	// singleline
			Screen.Attach(m);
			if (!time)
			{
				Screen.Input(m);
				this.Wait = true;	// so nothing happens while we're waiting for the message to close
			}
			while (!m.Completed)
			{
				Screen.Frame();
			}
			Screen.Detach(m);
			this.Wait = ow;
		}		
		this.RequestAction = function(ent)
		{
			if (ent instanceof Monster)
			{
				ent.Action();
			}
			else
			{
				this.ActionQueue.push(ent);
			}
		}
		this.CancelAction = function(ent)
		{
			for (var i = 0; i < this.ActionQueue.length; i++)
			{
				if (this.ActionQueue[i] == ent)
				{
					this.ActionQueue.splice(i, 1);
					i--;
				}
			}
			if (this.ActionIndex == this.ActionQueue.length)
			{
				this.ActionIndex = 0;
			}
		}
		this.DequeueAction = function(ent)
		{
			for (var i = 0; i < this.Actions.length; i++)
			{
				if (this.Actions[i] == ent)
				{
					this.Actions.splice(i, 1);
					i--;
				}
			}
		}
		this.Key = function(key)
		{
			// do nothing ^_^
		}
		
		this.Update = function()
		{
			if (this.Completed) return;

			if (!this.Wait)
			{
				for (var i = 0; i < Party.Characters.length; i++)
				{
					Party.Characters[i].BattleUpdate();
				}
				for (var i = 0; i < this.Monsters.length; i++)
				{
					this.Monsters[i].BattleUpdate();
				}
				while (this.Actions.length)
				{
					this.Actions.shift().ExecuteAction();
					this.CheckConditions();
					if (this.AlmostCompleted) return;
				}
			}
			
			if (this.ActionQueue.length)
			{
				if (this.ActionQueue[this.ActionIndex].Selected)
				{
					res = this.ActionQueue[this.ActionIndex].UpdateAction();
					if (this.ActionQueue[this.ActionIndex].HasSelectedAction)
					{
						if (this.ActionQueue[this.ActionIndex].ActionCanceled)
						{
							this.ActionIndex++;
						}
						else
						{
							this.ActionQueue.splice(this.ActionIndex, 1);
						}
						if (this.ActionIndex == this.ActionQueue.length)
						{
							this.ActionIndex = 0;
						}
					}
				}
				else
				{
					this.ActionQueue[this.ActionIndex].Action();
				}
			}
			else
			{
				this.ActionIndex = 0;
			}
			if (!this.Wait) this.CheckConditions();
		}
		
		this.CheckConditions = function()
		{
			if (!this.Completed)
			{
				if (!this.Monsters.length)
				{
					this.Won();
				}
				else
				{
					var won = true;
					for (var i = 0; i < this.Monsters.length; i++)
					{
						if (!this.Monsters[i].Dying)
						{
							won = false;
							break;
						}
					}
					if (won) this.AlmostCompleted = true;
				}
				var lost = true;
				for (var i = 0; i < Party.Characters.length; i++)
				{
					if (!Party.Characters[i].Status.Dead)
					{
						lost = false;
						break;
					}
				}
				if (lost) this.Lost();
			}		
		}
		this.Won = function()
		{
			this.Wait = true;
			this.AlmostCompleted = true;
			this.Completed = true;
			for (var i = 0; i < Party.Characters.length; i++)
			{
				Party.Characters[i].EndBattle();
			}
			this.DoMessage("Gained " + this.EXPGained + " EXP");
			this.DoMessage("Received " + this.GilGained + " Gil");
		}
		this.Lost = function()
		{
			this.Wait = true;
			this.AlmostCompleted = true;
			this.Completed = true;
			for (var i = 0; i < Party.Characters.length; i++)
			{
				Party.Characters[i].EndBattle();
			}
			this.DoMessage("Annihilated...");
		}
		this.Render = function()
		{
			this.Background.blit(0, 0);
			Window.DrawBlock(4, 164, 88, 72);
			Window.DrawBlock(100, 164, 216, 72);
			//Common.HP.blit(244, 166);
			Font.Message.setColorMask(Color.White);
			var y = 0;
			for (var i = 0; i < this.Monsters.length; i++)
			{
				if (this.Monsters[i].Visible)
				{
					Font.Message.drawText(12, 172 + 16 * y, this.Monsters[i].Name);
					y++;
				}
			}
			for (var i = 0; i < Party.Characters.length; i++)
			{
				Font.Message.drawText(108, 172 + 16 * i, Party.Characters[i].Name);
				Common.ATBBar.blit(268, 174 + 16 * i);
				if (Party.Characters[i].ATB == 255)
					Common.ATBFull.blit(272, 175 + 16 * i);
				else
					Common.ATBFill.transformBlit(272, 175 + 16 * i, 272 + (Party.Characters[i].ATB / 255) * 31, 175 + 16 * i, 272 + (Party.Characters[i].ATB / 255) * 31, 180 + 16 * i, 272, 180 + 16 * i);
				if (Party.Characters[i].DisplayHP == 0)
					Font.BattleSpecial.setColorMask(Color.Red);
				else if ((Party.Characters[i].DisplayHP / Party.Characters[i].MaxHP) * 100 < 20)
					Font.BattleSpecial.setColorMask(Color.Yellow);
				else
					Font.BattleSpecial.setColorMask(Color.White);
				Font.BattleSpecial.drawText(220 - Font.BattleSpecial.getStringWidth(Party.Characters[i].DisplayHP), 174 + 16 * i, Party.Characters[i].DisplayHP);
				Font.BattleSpecial.setColorMask(Color.White);
				Font.BattleSpecial.drawText(260 - Font.BattleSpecial.getStringWidth(Party.Characters[i].DisplayMP), 174 + 16 * i, Party.Characters[i].DisplayMP);
			}
			Font.BattleSpecial.drawText(4, 4, this.Actions.length);
			Font.BattleSpecial.drawText(4, 16, this.Wait ? "1" : "0");
		}
	},
	
	ColorBattleAnimation: function()
	{
		Screen.Frame(true);
		
					var cm = CreateColorMatrix(
						0, 255, 255, 255,
						0, 255, 230, 255,
						0, 255, 255, 245);		
		
		var img = GrabSurface(0, 0, 320, 240);
		img.applyColorFX(0, 0, 320, 240, cm);
		var oimg = img.clone();
		var step = 1;
		var step2 = 1;
		var lastFrame = GetTime();
		var cm;

		var bars = Random(4,6)*2;

		var cm2;
		while (step <= 255)
		{
			
			img.blit(0, 0);
			FlipScreen();
			
			if (lastFrame + 16 < GetTime())
			{
				lastFrame = GetTime();
				

				for (var y = 0; y < bars; y++)
				{
					var cm = CreateColorMatrix(
						step, 255, step, step,
						step, step, 230, step,
						step, step, step, 245);
					var cm2 = CreateColorMatrix(
						step2, 255, step2, step2,
						step2, step2, 255, step2,
						step2, step2, step2, 255);
					if (y % 2)
					{
						img.applyColorFX4(0, y * 240 / bars, 400, 240 / bars, cm, cm2, cm2, cm2);
					}
					else
					{
						img.applyColorFX4(0, y * 240 / bars, 400, 240 / bars, cm2, cm2, cm, cm2);
					}
				}
				
				step *= 1.2;
				if (step > 12) step2 *= 1.18;
				if (step > 255) step = 255;
				if (step2 > 120) break;
			}
		}
		var bsf = Screen.AttachPostRenderEffect(new FadeOut(Color.White));
		while (!bsf.Completed) Screen.Frame();
		Screen.DetachPostRenderEffect(bsf);
	},
	
	EnterBattleAnimation: function()
	{
		Screen.Frame(true);
		var img = GrabImage(0, 0, 320, 240);
		var currentAngle = 0;
		var centre = [160, 120];
		var zoomLevel = 1;
		var lastFrame = GetTime();
		while (zoomLevel < 1.4)
		{
			x = centre[0] - img.width * zoomLevel / 2;
			y = centre[1] - img.height * zoomLevel / 2;
			img.zoomBlit(x, y, zoomLevel);
			FlipScreen();
			if (lastFrame + 16 < GetTime())
			{
				zoomLevel += 0.08;
				lastFrame = GetTime();
			}
		}
		while (zoomLevel > 0)
		{
			x = centre[0] - img.width * zoomLevel / 2;
			y = centre[1] - img.height * zoomLevel / 2;
			img.zoomBlit(x, y, zoomLevel);
			FlipScreen();
			if (lastFrame + 16 < GetTime())
			{
				zoomLevel -= 0.08;
				lastFrame = GetTime();
			}
		}
	}
}
function TargetSelector(all, allowDead)
{
	this.All = false;
	this.AllowAll = all;
	this.DisplayIndex = 0;
	this.DisplayIndexCount = 0;
	this.Selected = 0;
	this.Target = 0;
	this.Canceled = false;
	this.AllowDead = allowDead;
	this.Monsters = Battle.CurrentBattle.Monsters;
	if (allowDead) this.Characters = Party.Characters;
	else
	{
		this.Characters = [];
		for (var i = 0; i < Party.Characters.length; i++)
		{
			if (!Party.Characters[i].Status.Dead) this.Characters.push(Party.Characters[i]);
		}
	}
	this.Update = function()
	{
		if (this.All)
		{
			this.DisplayIndexCount++;
			if (this.DisplayIndexCount == 2)
			{
				this.DisplayIndex++;
				Screen.Debugger.Text = this.DisplayIndex;
				if (this.Selected == 0 && this.DisplayIndex == this.Monsters.length) this.DisplayIndex = 0;
				if (this.Selected == 1 && this.DisplayIndex == this.Characters.length) this.DisplayIndex = 0;
				this.DisplayIndexCount = 0;
			}
		}
	}
	this.Key = function(key)
	{
		switch (key)
		{
			case Keys.Extra:
				if (this.AllowAll) this.All = !this.All;
				break;
			case Keys.Cancel:
				this.Canceled = true;
				this.Completed = true;
				break;
			case Keys.Accept:
				if (this.All)
				{
					if (this.Selected == 0) this.Targets = this.Monsters;
					else this.Targets = this.Characters;
				}
				else
				{
					this.Targets = [(this.Selected == 0 ? this.Monsters[this.Target] : this.Characters[this.Target])];
				}
				this.Completed = true;
				break;
			case Keys.Left:
			case Keys.Right:
				this.Selected = this.Selected == 1 ? 0 : 1;
				this.Target = Math.min(this.Target, (this.Selected == 0 ? this.Monsters.length : this.Characters.length) - 1);
				break;
			case Keys.Up:
				this.Target--;
				if (this.Target < 0) this.Target = this.Selected == 0 ? (this.Monsters.length - 1) : (this.Characters.length - 1);
				break;
			case Keys.Down:
				this.Target++;
				if (this.Target == (this.Selected == 0 ? this.Monsters.length : this.Characters.length)) this.Target = 0;
				break;
		}
	}	
	this.Render = function()
	{
		if (this.All)
		{
			if (this.Selected == 0)
			{
				// Monsters
				Common.CursorR.blit(this.Monsters[this.DisplayIndex].GetBaseX(), this.Monsters[this.DisplayIndex].GetBaseY() - 8);
			}
			else
			{
				// Characters
				Common.Cursor.blit(this.Characters[this.DisplayIndex].GetBaseX() - 16, this.Characters[this.DisplayIndex].GetBaseY() - 8);
			}
		}
		else
		{
			if (this.Selected == 0)
			{
				Common.CursorR.blit(this.Monsters[this.Target].GetBaseX(), this.Monsters[this.Target].GetBaseY() - 8);
			}
			else
			{
				Common.Cursor.blit(this.Characters[this.Target].GetBaseX() - 16, this.Characters[this.Target].GetBaseY() - 8);
			}
		}
	}
}

function ChangeRow(person)
{
	this.Person = person;
	this.LeadUp = false;
	this.Invoke = function(source, targets)
	{
		for (var i = 0; i < targets.length; i++)
		{
			targets[i].ChangeRow();
		}
	}
}