function ChoiceMenuCreator(params)
{
	var m = new ChoiceMenu(params.x, params.y, params.w, params.h);
	for (var i in params)
	{
		m[i] = params[i];
	}
	return m;
}
function ChoiceMenu(x, y, w, h)
{
	this.x = x;
	this.RightCancels = false;
	this.LeftCancels = false;
	this.y = y;
	this.DrawMode = Window.DrawBlock;
	this.w = w;
	this.h = h;
	this.LeftFunc = false;
	this.RightFunc = false;
	this.SlideIn = 0;
	this.Mode = 's';
	this.Items = [];
	this.Selected = 0;
	this.ScrollPosition = 0;
	this.Cursor = new Cursor(this.x - 10, this.y + 8);
	this.LineHeight = 16;
	this.Lines = this.h / this.LineHeight;
	this.AllowCancel = false;
	this.AddItem = function(item, enabled, retfunc, p, nonew)
	{
		this.Items.push({Text: item, Enabled: enabled, RetFunc: retfunc, RetFuncParam: p, NoNew: nonew});
	}
	this.Init = function()
	{
		Screen.Attach(this.Cursor);
	}
	this.FigureHeight = function()
	{
		this.h = this.Items.length * this.LineHeight + 8;
		this.Lines = this.h / this.LineHeight;
	}
	this.Render = function()
	{
		if (this.SlideIn)
		{
			this.DrawMode(x, y, w, this.SlideIn);
			SetClippingRectangle(x - 26, y, w + 26, this.SlideIn);
			for (var i = this.ScrollPosition; i < Math.min(this.ScrollPosition + this.Lines, this.Items.length); i++)
			{
				if (this.Items[i].Enabled)
					Font.Message.setColorMask(Color.White);
				else
					Font.Message.setColorMask(Color.White50);
				Font.Message.drawText(this.x + 8, this.y + 8 + this.LineHeight * (i - this.ScrollPosition), this.Items[i].Text);
				if (this.Items[i].EndText) Font.Message.drawText(this.x + this.w - 8 - Font.Message.getStringWidth(this.Items[i].EndText), this.y + 8 + this.LineHeight * (i - this.ScrollPosition), this.Items[i].EndText);
			}
			SetClippingRectangle(0, 0, 320, 240);
		}
	}
	this.Update = function()
	{
		if (this.Mode == 's' || this.Mode == 'r')
		{
			if (this.SlideIn < this.h)
			{
				this.SlideIn += 640 / this.h;
			}
			if (this.SlideIn >= this.h)
			{
				this.SlideIn = this.h;
				if (this.Mode == 's') this.Mode = 'n';
			}
		}
		if (this.Mode == 'o')
		{
			if (this.SlideIn > 0)
			{
				if (this.SlideIn == this.h) Screen.Detach(this.Cursor);
				this.SlideIn -= 800 / this.h;
			}
			if (this.SlideIn <= 0)
			{
				this.SlideIn = 0;
				this.Completed = true;
			}
		}
		if (this.Mode == 'r')
		{
			if (this.Ret.Completed)
			{
				if (!this.Ret.Canceled)
				{
					this.Return = this.Ret.Return;
					this.Mode = 'o';
					this.Completed = true;
					this.Canceled = false;
				}
				else
				{
					this.Mode = 'n';
				}
				Screen.Detach(this.Ret);
			}
		}
	}
	this.CleanDetach = function()
	{
		if (this.Ret)
		{
			if (this.Ret.CleanDetach) this.Ret.CleanDetach();
			Screen.Detach(this.Ret);
		}
		Screen.Detach(this.Cursor);
	}
	this.Key = function(key)
	{
		var moved = false;
		if (this.Mode != 'o')
		{
			switch (key)
			{
				case Keys.Cancel:
					if (this.AllowCancel)
					{
						this.Mode = 'o';
						this.Canceled = true;
					}
					break;
				case Keys.Right:
					if (this.RightCancels)
					{
						if (this.AllowCancel)
						{
							this.Mode = 'o';
							this.Canceled = true;
						}
					}
					else if (this.RightMenu)
					{
						this.Mode = 'r';
						f = this.RightMenu.RetFunc;
						if (!this.RightMenu.NoNew)
							this.Ret = new f(this.RightMenu.RetFuncParam);
						else
							this.Ret = f(this.RightMenu.RetFuncParam);
						Screen.Attach(this.Ret);
						if (this.Ret.Init) this.Ret.Init();
						Screen.Input(this.Ret);
					}
					break;
				case Keys.Left:
					if (this.LeftCancels)
					{
						if (this.AllowCancel)
						{
							this.Mode = 'o';
							this.Canceled = true;
						}
					}
					else if (this.LeftMenu)
					{
						this.Mode = 'r';
						f = this.LeftMenu.RetFunc;
						if (!this.LeftMenu.NoNew)
							this.Ret = new f(this.LeftMenu.RetFuncParam);
						else
							this.Ret = f(this.LeftMenu.RetFuncParam);
						Screen.Attach(this.Ret);
						if (this.Ret.Init) this.Ret.Init();
						Screen.Input(this.Ret);
					}
					break;
				case Keys.Accept:
					if (this.Items[this.Selected].Enabled)
					{
						if (this.Items[this.Selected].RetFunc)
						{
							this.Mode = 'r';
							f = this.Items[this.Selected].RetFunc;
							if (!this.Items[this.Selected].NoNew)
								this.Ret = new f(this.Items[this.Selected].RetFuncParam);
							else
								this.Ret = f(this.Items[this.Selected].RetFuncParam);
							Screen.Attach(this.Ret);
							if (this.Ret.Init) this.Ret.Init();
							Screen.Input(this.Ret);
						}
						else
						{
							this.Return = this.Selected;
							this.Mode = 'o';
							this.Canceled = false;
						}
					}
					break;
				case Keys.Down:
					var moved = true;
					if (this.Selected < this.Items.length - 1) this.Selected++;
					break;
				case Keys.Up:
					var moved = true;
					if (this.Selected > 0) this.Selected--;
					break;
			}
		}
		if (moved)
		{
			this.Cursor.MoveTo(this.x - 10, this.y + 8 + (this.Selected - this.ScrollPosition) * this.LineHeight, 2)
		}
	}
}