function Decompress(file)
{
	var file = OpenRawFile(file + ".c");
	this.dcs = (file.read(1)[0] << 8) | file.read(1)[0];
	this.position = 0;
	this.getSize = function() { return this.dcs; }
	this.getPosition = function() { return this.position; }
	this.setPosition = function(value) { this.position = value; }
	this.stream = "";
	while (file.getPosition() < file.getSize())
	{
		var block_type = file.read(1)[0];
		if (block_type == 0x00)
		{
			// uncompressed block
			var block_size = file.read(1)[0];
			this.stream += CreateStringFromByteArray(file.read(block_size));
		}
		else if (block_type == 0x01)
		{
			// compressed rblock
			var repeats = file.read(1)[0];
			var block_size = file.read(1)[0];
			var block_offset = file.read(1)[0];
			var here = file.getPosition();
			file.setPosition(here - 4 - block_offset);
			var str = CreateStringFromByteArray(file.read(block_size));
			for (var i = 0; i < repeats; i++)
			{
				this.stream += str;
			}
			file.setPosition(here);
		}
		else
		{
			// compressed block
			var block_size = block_type;
			var block_offset = file.read(1)[0];
			var here = file.getPosition();
			file.setPosition(here - 2 - block_offset);
			var s = CreateStringFromByteArray(file.read(block_size));
			this.stream += s;
			file.setPosition(here);
		}
	}
	this.read = function(amount)
	{
		var s = this.stream.substr(this.position, amount);
		this.position += amount;
		return CreateByteArrayFromString(s);
	}
	this.dcs = this.stream.length;
}