var Map = {
	InputPerson: false,
	
	Moving: false,
	MovementStepsLeft: 0,
	EnableWallHack: false,
	
	HUD: false,
	
	RandomBattles: false,
	
	InteractionMode: 0,
	
	InteractionModes: {
		Talk: 0,
		Card: 1
	},
	
	SetBattles: function(b)
	{
		Map.RandomBattles = b;
	},
	
	Battle: function(type)
	{
		Battle.Start(Map.RandomBattles[type][Random(0,Map.RandomBattles[type].length-1)]);
	},
	
	FadeOut: function()
	{
		var fade = new FadeOut();
		Screen.AttachPostRenderEffect(fade);
		while (!fade.Completed)
		{
			Screen.Frame();
		}
		Screen.DetachPostRenderEffect(fade);
	},
	
	FadeIn: function()
	{
		var fade = new FadeIn();
		Screen.AttachPostRenderEffect(fade);
		while (!fade.Completed) Screen.Frame();
		Screen.DetachPostRenderEffect(fade);
	},
	
	Change: function(map, fade)
	{
		if (!IsMapEngineRunning())
		{
			this.HUD = new MapHUD()
			Screen.Attach(this.HUD);
			MapEngine(map, 60);
		}
		else
		{
			if (fade) Map.FadeOut();
			ChangeMap(map);
			if (fade) Map.FadeIn();
		}
	},
	
	AttachInput: function(player)	// tile movement replacement
	{
		while (AreKeysLeft()) GetKey();	// clear plz!!
		this.InputPerson = player;
		AttachInput(player);
	},
	
	SetPersonTile: function(person, x, y)
	{
		SetPersonX(person, x*16+7);
		SetPersonY(person, y*16+7);
	},
	
	UpdateMovement: function()
	{
		if (this.InputPerson)
		{
			var x = GetPersonX(this.InputPerson);
			var y = GetPersonY(this.InputPerson);
			var layer = GetPersonLayer(this.InputPerson);
			if (this.MovementStepsLeft)
			{
				this.MovementStepsLeft--;
				QueuePersonCommand(this.InputPerson, this.Moving, true);
				if (this.MovementStepsLeft == 0)
				{
					//if (IsTriggerAt(x, y, layer))
					//{
//						ExecuteTrigger(x, y, layer);
					//}
					AttachInput(this.InputPerson);
				}
			}
			else
			{
				this.Moving = false;
				var face = false;
				if (IsKeyPressed(Keys.Up))
				{
					if (!IsPersonObstructed(this.InputPerson, x, y - 16))
					{
						this.Moving = COMMAND_MOVE_NORTH;
					}
					face = COMMAND_FACE_NORTH;
				}
				else if (IsKeyPressed(Keys.Left))
				{
					if (!IsPersonObstructed(this.InputPerson, x - 16, y))
					{
						this.Moving = COMMAND_MOVE_WEST;
					}
					face = COMMAND_FACE_WEST;
				}
				else if (IsKeyPressed(Keys.Right))
				{
					if (!IsPersonObstructed(this.InputPerson, x + 16, y))
					{
						this.Moving = COMMAND_MOVE_EAST;
					}
					face = COMMAND_FACE_EAST;
				}
				else if (IsKeyPressed(Keys.Down))
				{
					if (!IsPersonObstructed(this.InputPerson, x, y + 16))
					{
						this.Moving = COMMAND_MOVE_SOUTH;
					}
					face = COMMAND_FACE_SOUTH;
				}
				
				if (this.Moving)
				{
					DetachInput();
					this.MovementStepsLeft = GetTileWidth();
				}
				if (face) QueuePersonCommand(this.InputPerson, face, true);
			}
			
			while (AreKeysLeft())
			{
				switch (GetKey())
				{
					case Keys.Menu:
						//Menu.Open(); // NO
						break;
					case Keys.Extra:
						// change this
						this.InteractionMode = (this.InteractionMode == 1) ? 0 : 1;
						break;
				}
			}
		}
	}
}

function MapHUD()
{
	this.Visible = true;
	this.Completed = false;
	this.Render = function()
	{
		if (!this.Visible) return;
		Font.Message.drawText(5, 5, (["Talk", "Card"])[Map.InteractionMode]);
	}
}