function Message(text, singleline)
{			
	this.Text = text;
	this.Completed = false;
	var lines = Scene._WrapText(text, 288);
	this.Pages = Scene._PageLines(lines, singleline ? 1 : 4);
	this.ScrollInHeight = 0;
	this.CurrentPage = 0;
	this.CurrentLine = 0;
	this.CurrentPosition = 0;
	this.Finished = false;
	this.SingleLine = singleline;
	this.Mode = 'n';	// n: normal, also scroll-in while displaying
										// s: waiting to scroll text (for paging)
										// a: scrolling text
										// o: scroll-out
	this.ScrollOffset = 0;
	this.AcceptHeld = false;	// so you can't accept a message just by holding down to speed it up...
	this.Key = function(k)
	{
		switch (k)
		{
			case Keys.Accept:
				if (!this.Finished)
				{
					if (this.Mode == 's' && !this.AcceptHeld)
					{
						this.Mode = 'a';
					}
					this.AcceptHeld = true;
				}
				else
				{
					if (!this.AcceptHeld)
					{
						this.Mode = 'o';
					}
				}
				break;
		}
	}
	
	this.Update = function()
	{
		if (!IsKeyPressed(Keys.Accept) && Screen.HasInput(this))
		{
			this.AcceptHeld = false;
		}
		if (this.Mode == 'o')
		{
			if (this.ScrollInHeight > 0)
			{
				this.ScrollInHeight -= 6;
			}
			else
			{
				this.Completed = true;
			}
		}
		else
		{
			if (this.ScrollInHeight < (this.SingleLine ? 24 : 72))
			{
				this.ScrollInHeight += 6;
			}
		}
		if (!this.Finished)
		{
			if (this.Mode == 'a')
			{
				this.ScrollOffset -= 2 * (this.AcceptHeld ? 1.5 : 1);
				if (this.ScrollOffset <= (this.SingleLine ? -24 : -64))
				{
					this.Mode = 'n';
				}
			}
			else if (this.Mode == 's')
			{
				// do nothing?
			}
			else
			{
				this.CurrentPosition+= 1 * (this.AcceptHeld?1.5:1);
				if (this.CurrentPosition >= this.Pages[this.CurrentPage][this.CurrentLine].length)
				{
					this.CurrentLine++;
					this.CurrentPosition = 0;
					if (this.CurrentLine == this.Pages[this.CurrentPage].length)
					{
						this.CurrentLine = 0;
						this.CurrentPage++;
						if (this.CurrentPage == this.Pages.length)
						{
							this.Finished = true;
						}					
						else
						{
							this.Mode = 's';
							this.ScrollOffset = 0;
						}
					}
				}
			}
		}
	}
	
	this.Render = function()
	{
		if (this.Mode == 'a' || this.Mode == 's')
		{
			Window.Draw(12, 12, 296, (this.SingleLine ? 24 : 72));
			SetClippingRectangle(20, 20, 296, this.ScrollInHeight);
			for (var i = 0; i < this.Pages[this.CurrentPage-1].length; i++)
			{
				Font.Message.drawText(20, 20 + 16 * i + this.ScrollOffset, this.Pages[this.CurrentPage-1][i]);
			}
			SetClippingRectangle(0, 0, 320, 240);
		}
		else if (this.Mode == 'n' || this.Mode == 'o')
		{
			Window.Draw(12, 12, 296, Math.min(this.ScrollInHeight, (this.SingleLine ? 24 : 72)));
			SetClippingRectangle(20, 20, 296, this.ScrollInHeight);
			if (!this.Finished)
			{
				for (var i = 0; i < this.CurrentLine; i++)
				{
					Font.Message.drawText(20, 20 + 16 * i, this.Pages[this.CurrentPage][i]);
				}
				Font.Message.drawText(20, 20 + 16 * this.CurrentLine, this.Pages[this.CurrentPage][this.CurrentLine].substr(0, this.CurrentPosition));
			}
			else
			{
				for (var i = 0; i < this.Pages[this.Pages.length-1].length; i++)
				{
					Font.Message.drawText(20, 20 + 16 * i, this.Pages[this.Pages.length-1][i]);
				}
			}
			SetClippingRectangle(0, 0, 320, 240);
		}
	}
}


function TextBox(x, y, w, h, text)
{
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.Text = text;
	this.Render = function()
	{
		Window.Draw(this.x, this.y, this.w, this.h);
		Font.Message.drawText(this.x + (this.w - Font.Message.getStringWidth(this.Text)) / 2, this.y + 4, this.Text);
	}
}