function Monster(data)
{
	this.Data = data;
	this.Name = data.Name;
	
	this.Level = data.Level;
	this.EXP = data.EXP;
	this.Gil = data.Gil;
	this.Stats = data.Stats;
	this.HP = data.HP;
	this.MP = data.MP;
	
	this.Attacks = [];
	
	for (var i = 0; i < data.Attacks.length; i++)
	{
		this.Attacks.push(new Attack(Data.Load("attacks/" + data.Attacks[i] + ".attackData")));
	}
	//this.Specialty = data.Specialty;
	
	this.ATB = 0;
	
	this.Status = {
		Haste: false,
		Slow: false
	}
	
	this.Spriteset = LoadSpriteset(data.Sprite);
	this.currentX = 0;
	this.BackRow = false;
	this.currentY = 0;
	this.Destroy = false;
	this.x = 0;
	this.y = 0;
	this.Visible = true;
	this.MoveStart = 0;
	this.MoveX = 0;
	this.MoveY = 0;
	this.Moving = false;
	this.AnimFrame = 0;
	this.AnimDelay = 0;
	this.Facing = "east";
	this.Direction = Scene._FindSpritesetDirection(this.Spriteset, "east");
	this.GetBaseX = function()
	{
		return this.currentX + (this.Spriteset.base.x1 + this.Spriteset.base.x2) / 2;
	}
	this.GetBaseY = function()
	{
		return this.currentY + (this.Spriteset.base.y1 + this.Spriteset.base.y2) / 2;
	}
	this.SetDirection = function(dir)
	{
		this.Direction = Scene._FindSpritesetDirection(this.Spriteset, dir);
		this.AnimFrame = 0;
	}
	this.Render = function()
	{
		if (this.Visible)
		{
			if (this.Dying)
				this.Spriteset.images[this.Direction.frames[this.AnimFrame].index].blitMask(this.currentX, this.currentY, this.DyingMask);
			else
				this.Spriteset.images[this.Direction.frames[this.AnimFrame].index].blit(this.currentX, this.currentY);
		}
		//GetSystemFont().drawText(this.currentX, this.currentY, this.ATB);
	}
	this.MoveTo = function(x, y, frames)
	{
		this.MoveStart = GetTime();
		this.MoveX = (x - this.currentX) / frames;
		this.MoveY = (y - this.currentY) / frames;
		this.Moving = true;
		this.MoveFrames = frames;
		this.MoveFrameI = 0;
		this.x = this.currentX;
		this.y = this.currentY;
	}
	this.AnimatePose = function(pose)
	{
		this.AnimateDirection(this.Facing + "-" + pose);
	}
	
	this.TakeDamage = function(damage)
	{
		this.HP -= damage;
		this.Check();
	}
	this.Check = function()
	{
		if (this.HP <= 0)
		{
			this.HP = 0;
			this.PlayDeadAnim();
			this.ATB = 0;
			this.Status.Dead = true;
			Battle.CurrentBattle.EXPGained += this.EXP;
			Battle.CurrentBattle.GilGained += this.Gil;
			if (this.WaitingForAction)
			{
				Battle.CurrentBattle.DequeueAction(this);
			}
		}
	}
	this.PlayDeadAnim = function()
	{
		this.Dying = true;
		this.DyingMask = CreateColor(255, 255, 255);
		this.DyingStage = "w";
		this.DyingC = 0;
	}
	this.AnimateDirection = function(dir)
	{
		var o = this.Direction.name;
		this.SetDirection(dir);
		var sdirection = this.Direction;
		for (var i = 0; i < sdirection.frames.length; i++)
		{
			this.AnimFrame = i;
			Screen.Frames(sdirection.frames[i].delay);
		}
		this.SetDirection(o);
	}
	this.Update = function()
	{
		if (this.Dying)
		{
			if (this.DyingStage == "w")
			{
				this.DyingC++;
				if (this.DyingC == 40)
				{
					this.DyingStage = "r";
					this.DyingC = 0;
				}
			}
			else if (this.DyingStage == "r")
			{
				this.DyingC += 24;
				if (this.DyingC >= 255)
				{
					this.DyingStage = "f";
					this.DyingC = 255;
				}
				else
				{
					this.DyingMask.blue = 255 - this.DyingC;
					this.DyingMask.green = 255 - this.DyingC;
				}
			}
			else
			{
				this.DyingC -= 8;
				if (this.DyingC <= 0)
				{
					this.Dying = false;
					this.Visible = false;
					Battle.CurrentBattle.RemoveMonster(this);
				}
				else
				{
					this.DyingMask.alpha = this.DyingC;
				}
			}
		}
		if (this.Moving)
		{
			this.currentX += this.MoveX;
			this.currentY += this.MoveY;
			this.MoveFrameI++;
			if (this.MoveFrameI == this.MoveFrames)
			{
				this.Moving = false;
			}
		}
	}
	this.ResetATB = function()
	{
		var n1 = Math.max(120 - this.Stats.Speed, 1);
		if (this.Status.Haste) n1 = Math.floor(n1 / 2);
		else if (this.Status.Slow) n1 = n1 * 2;
		this.ATB = 255 - n1;
	}
	
	this.BattleUpdate = function()
	{
		if (!this.Status.Dead && !this.WaitingForAction)
		{
			this.ATB += 0.5;
			if (this.ATB == 255)
			{
				this.WaitingForAction = true;
				Battle.CurrentBattle.RequestAction(this);
			}
		}
	}	
	
	this.GetEquipmentStat = function(stat)
	{
		return this.Stats[stat];
	}
	
	this.GetStat = this.GetEquipmentStat;
	
	this.Action = function()
	{
		Battle.CurrentBattle.QueueAction(this);
	}
	this.ExecuteAction = function()
	{
		Battle.CurrentBattle.Wait = true;
		
				var targets = [];
		var attack = this.Attacks[Random(0, this.Attacks.length - 1)];
		if (attack.Target == "Opponent")
		{
			var p = [];
			for (var i = 0; i < Party.Characters.length; i++)
			{
				if (!Party.Characters[i].Status.Dead) p.push(Party.Characters[i]);
			}
			targets.push(p[Random(0, p.length - 1)]);
		}
		else if (attack.Target == "Self")
		{
			targets.push(this);
		}
		if (attack.ShowName)
		{
			Screen.Attach(new BattleAttackName(attack.Name)).Monitor = true;
		}
		this.AnimatePose("attack");
		attack.Invoke(this, targets);
		
		Battle.CurrentBattle.Wait = false
	
		this.WaitingForAction = false;
		this.ResetATB();
	}
	
	this.TriggerScript = function(s, ScriptArguments)
	{
		if (this.Data.Scripts && this.Data.Scripts[s])
			return RunScript(this.Data.Scripts[s], true, ScriptArguments);
		return null;
	}
	if (this.TriggerScript("Create", {Monster: this}) == false)
	{
		this.Destroy = true;
	}
}